#include <stdio.h>

char *tage[] = { "Sonntag", "Montag", "Dienstag",
	         "Mittwoch", "Donnerstag", "Freitag", "Sonnabend" };

/* Berechnet die Anzahl der Tage zwischen dem 1.1 des Jahres j 
   und dem 1.1. des Jahres jj modulo 7 (gregorianisch)         */

int w_diff(int j, int jj) {
  int d;
  j--; jj--;
  d = (j - jj + j/4 - j/100 + j/400 - jj/4 + jj/100 - jj/400) % 7;
  return d >= 0 ? d : 7+d;
}

/* Schaltjahr */

int schalt(int j) {
  if ( j % 4 == 0 && j % 100 != 0 || j % 400 == 0 ) 
    return 1;
  return 0;
}

/* Anzahl der am 1.1., 1.2., 1.3. usw. im 
   Nicht-Schaltjahr verflossenen Tage   */
int days[] = {0,31,59,90,120,151,181,212,243,273,304,334,365};

/* gibt fuer ein Datum die Nummer des Tages im Jahr zurueck */
int tag_im_jahr(int t, int m, int j) {
  return t + days[m-1] + (m<=2 ? 0 : schalt(j));
}

/* Ausgabe des Wochentages eines gregorianischen Datums  */

main() {
  int t,m,j, n;
  while(1) {
    printf(" t m j : ");
    scanf("%d%d%d", &t, &m, &j);
    printf("Wochentag  1. 1. %4d : %s\n",j, tage[ w_diff(j, 1995) ] );
    n = (w_diff(j, 1995) + tag_im_jahr(t,m,j) - 1 ) % 7;
    printf("Wochentag %2d.%2d. %4d : %s\n",t,m,j, tage[n] );
  }
}
