/* titel: springer.c, Roesselsprung-Programm */

#define ZZ 8                                 /* Feldgroesse */
int z;

int FELD[ ZZ ][ ZZ ];                        /* Feld                  */
int a[] = { 2, 1, -1, -2, -2, -1,  1,  2 };  /* Koordinaten der       */
int b[] = { 1, 2,  2,  1, -1, -2, -2, -1 };  /* Springerzuege         */

int xx=0, yy=0;      /* Fuer zyklische Loesung beliebiges Anfangsfeld */

main() {
    void drucke();
    while ( 1 ) {
      printf("Zeilen: "); scanf("%d",&z);
      if ( z <= 1 || z > ZZ)
	exit(0);
      { int i,j;
        for (i = 0; i < z; i++)
	  for (j = 0; j < z; j++)
	    FELD[i][j] = 0;
      }
      FELD[xx][yy] = 1;
      if ( versuche(xx,yy) )
	drucke();
      else printf("\nKeine Loesung\n");
    }
}

int versuche( int x, int y) {     
      int k, q, u, v;
      for (k = q = 0; q == 0 && k < 8; k++) {
	  u = x+a[k]; v = y+b[k];
	  if ( 0 <= u && u < z && 0 <= v && v < z && FELD[u][v] == 0 ){	
              FELD[u][v] = FELD[x][y] + 1;		
	      if ( FELD[u][v] == z*z )
		  q = 1;
	      else {                /*  FELD[u][v] < z*z */
		if (u==1 && v==2)   /* Keine zyklische Loesung moeglich */
		  q = 0;
		else
		  q = versuche(u,v);
		if (q == 0)
		  FELD[u][v] = 0;
	      }
          }
      }
      return q;
}

void drucke() {
     int i, j;
     printf("\n");
     for (i = 0; i < z; i++) {
         for (j = 0; j < z; j++)
             printf("%3d", FELD[i][j]);
         printf("\n");
     }
}

/* Loesungen:

z=6:

  1 14 21 30 35 12
 22 29 36 13 20 31
 15  2 23 32 11 34
 28  5  8 17 24 19
  7 16  3 26 33 10
  4 27  6  9 18 25

z=7:




*/
