/* titel: springer.c, Roesselsprung-Programm */

#define ZZ 8                                 /* Feldgroesse */
int z = ZZ;

int FELD[ ZZ ][ ZZ ];                        /* Feld                  */
typedef struct vect { int x; int y;} vect;

vect v[] = { { 2, 1}, { 1, 2}, {-1, 2}, {-2, 1}, 
	     {-2,-1}, {-1,-2}, { 1,-2}, { 2,-1}};

vect x = {0,0};     /* Anfangswerte irrelevant fuer cylc. Loesung */

int init() {
  int i,j;
  for (i=0; i<z; i++)
    for (j=0; j<z; j++)
      FELD[i][j] = 0;
  return 0;
}

vect add(vect u, vect v) {
  vect w;
  w.x = u.x + v.x; w.y = u.y + v.y;
  return w;
}

int * feld(vect x) {
  return &FELD[x.x][x.y];
}

int infeld(vect x) {
  return (0 <= x.x && x.x < z && 0 <= x.y && x.y < z);
}

int springer(vect u, vect v) {
  return ( abs(u.x-v.x)*abs(u.y-v.y) == 2 ) ;
}

main() {
    while ( 1 ) {
      printf("Zeilen: "); scanf("%d",&z);
      if ( z <= 1 || z > ZZ) exit(0);
      init();
      *feld(x) = 1;
      if ( versuche(x) )
	drucke();
      else printf("\nKeine Loesung\n");
    }
}

int versuche(vect x) {     
  int k, q; vect u;

  for (k = q = 0; q == 0 && k < 8; k++) {
    u = add(x, v[k]);
    if ( infeld(u)  &&  *feld(u) == 0 ) {	
      *feld(u) = *feld(x) + 1;
      if ( *feld(u) == z*z )   
	q = 1;
      else {
	if (u.x==1 && u.y==2 ) /* zykl. nicht mehr moeglich */
	  q = 0; 
	else
	  q = versuche(u);
	if ( q == 0 )
	  *feld(u) = 0;
      } 
    }
  }
  return(q);
}

int drucke() {
  int i, j;
  printf("\n");
  for (i = 0; i < z; i++) {
    for (j = 0; j < z; j++)
      printf("%3d", FELD[i][j]);
    printf("\n");
  }
  return 0;
}
