#include <stdio.h>
#include <string.h>

char *tage[] = { "Sonntag", "Montag", "Dienstag",
	         "Mittwoch", "Donnerstag", "Freitag", "Sonnabend" };

struct datum {
  int  t;  int  m; int j;  
};

struct monat {
  char *name;  int  laenge;
};

struct monat mon[] = {
  {"Januar",   31},   {"Februar",  28},  {"Maerz",    31},
  {"April",    30},   {"Mai",      31},  {"Juni",     30},
  {"Juli",     31},   {"August",   31},  {"September",30},
  {"Oktober",  31},   {"November", 30},  {"Dezember", 31}
};

int schalt(struct datum d) {
  return ( d.j % 4 == 0 &&  d.j % 100 != 0 || d.j % 400 == 0 );
}

int mon_laenge(struct datum d) {
  if (d.m < 1 || d.m > 12) return 0;
  return mon[d.m-1].laenge + (d.m==2 && schalt(d));
}

char *mon_name(struct datum d) {
  return mon[d.m-1].name;
}

int jahr_laenge(struct datum d) {
  return 365 + schalt(d);
}

void printdatum(struct datum d) {
  printf("%d. %s, %d\n", d.t, mon_name(d), d.j);
}

struct datum makedatum(int tag, int monat, int jahr) {
  struct datum d;
  d.t  = tag; d.m  = monat; d.j  = jahr;
  /* Fehler bei mon_laenge fuer d.m out of range */
  if ( mon_laenge() == 0 || d.t < 1 || d.t > mon_laenge(d) ) {
    printf("Das Datum gibt es nicht : "); printdatum(d);
    exit(1);

  }
  return d;
}

int tag_im_jahr(struct datum d) {
  struct datum dd;
  int n;
  dd = d;
  n = d.t;
  for (dd.m=1; dd.m < d.m; dd.m++) 
    n += mon_laenge(dd);
  return n;
}

/* Berechne u - v */
int diff(struct datum u, struct datum v) { 
  int n;
  if (u.j < v.j) 
    return -diff(v,u);
  n = tag_im_jahr(u);
  for(u.j = u.j - 1; u.j >= v.j; u.j--) 
    n += jahr_laenge(u);
  n -=  tag_im_jahr(v);
  return n;
}

struct datum inc_jahr(struct datum v) {
  v.t = v.m = 1; v.j++;
  return v;
}

/* Liefert das Datum des 1. des Folgemonats. */
struct datum inc_monat(struct datum v) {
  if (v.m < 12) {
    v.t = 1; v.m++; 
  }
  else 
    v = inc_jahr(v);
  return v;
}
  /* Liefert das Datum des folgenden Tages */
struct datum inc_tag(struct datum v) {
  if ( v.t < mon_laenge(v) ) 
    v.t++;
  else
    v = inc_monat(v);
  return v;
}

struct datum add(struct datum u, int t) {
  if (t >= 0) {
    while (u.t + t > mon_laenge(u)) { 
      t -= (mon_laenge(u) - u.t + 1);
      u = inc_monat(u);
    }
    u.t += t;
    return u;
  }
  printf ("Noch nicht implementiert (t negativ) : %d\n", t);
  exit(1);
}

char *wochentag(struct datum d) {
  struct datum e; int t;
  e = makedatum(31,12,2000); /* ist ein Sonntag */
  t = diff(d,e) % 7;
  if ( t < 0 )  
    t += 7;
  return tage[t];
}

main() { 
  int t, m, j;
  struct datum d, dd;
  while(1) {
    printf("Bitte Tag Monat Jahr (als Zahlen) eingeben : ");
    scanf("%d %d %d", &t, &m, &j);
    d = makedatum(t,m,j);
    printf("Das Datum ist : "); printdatum(d);
    printf("Es ist der %d-te Tag im Jahr %d.\n", tag_im_jahr(d), d.j);
    printf("Es ist ein %s.\n", wochentag(d) );
    printf("Der naechste Tag ist : ");  printdatum( inc_tag(d) ); 
    printf ("wieviele Tage dazu ?"); scanf("%d", &t);
    dd = add(d,t);
    printdatum( dd );
    printf("Unterschied nach diff : %d\n", diff(d,dd));
  }
}
