// quicksort.cc  Template-Version
#include <iostream.h>
#include "string-class.h" //Diese Datei muss im aktuellen Verzeichnis sein.

static int scount=0;      // Zaehler fuer die Aufrufe von swap
template <class T>                  // swap template
inline void swap(T& x, T& y) {
  T tmp = x; 
  x = y; y = tmp;
  scount++;
}

template <class T>                 // Ausgabe-Template
ostream& out(T v[], int size) {
  for (int i=0; i<size; i++)
    cout << v[i] << ' ';
  return cout;
}

template <class T>                  // Quicksort-Template 
void quicksort(T v[], int n) {      // cf. K&R, p.87, dort fuer C und festen Typ
  if(n <= 1)
    return;
  int last = 0;
  for (int i = 1; i < n; i++) 
    if (v[0] > v[i])
      swap(v[++last], v[i]);
  swap(v[0],v[last]);
  quicksort(v, last); 
  quicksort(v+last+1, n-last-1);
}
#define size(A) (sizeof((A))/sizeof((A)[0]))

// Diese Arrays verschiedener Typen werden sortiert:
int    a[] = { 3, 1, 4, 1, 5, 9, 2, 6, 3, 1, 4, 1, 5, 9, 2, 6};
float  b[] = { 3.1, 4.1, 5.9, 2.6, 5.3, 5.8, 9.7, 9.3, 
	       3.1, 4.1, 5.9, 2.6, 5.3, 5.8, 9.7, 9.3};
string s[] = { "Sonntag",  "Montag",     "Dienstag",
	       "Mittwoch", "Donnerstag", "Freitag", "Sonnabend", 
	       "Mittwoch", "Donnerstag", "Freitag", "Sonnabend" };
main() {
  scount=0;
  quicksort(a,size(a)); out(a,size(a))<<'\n'; 
  cout<<scount<<'\n';scount=0;
  quicksort(b,size(b)); out(b,size(b))<<'\n';
  cout<<scount<<'\n';scount=0;
  quicksort(s,size(s)); out(s,size(s))<<'\n';
  cout<<scount<<'\n';scount=0;
} 
