#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include "string-class.h"

string tage[] = { "Sonntag", "Montag", "Dienstag",
	         "Mittwoch", "Donnerstag", "Freitag", "Sonnabend" };
struct monat {
  string name; int laenge;
};

struct monat mon[] = {
  {"Januar",   31},   {"Februar",  28},  {"Maerz",    31},
  {"April",    30},   {"Mai",      31},  {"Juni",     30},
  {"Juli",     31},   {"August",   31},  {"September",30},
  {"Oktober",  31},   {"November", 30},  {"Dezember", 31}
};

void printdatum();
class datum {
  int  t; int m; int j;  
public:
  datum() {};
  datum(int tag, int monat, int jahr) {
    t = tag; m = monat; j = jahr;
    if ( mon_laenge() == 0 || t < 1 || t > mon_laenge() ) {
      cout << "Das Datum gibt es nicht : " << t << "." << m << "." << j <<"\n";
      exit(1);
    }
  }
  int jahr() { return j; }
  int schalt() { 
    return ( j % 4 == 0 &&  j % 100 != 0 || j % 400 == 0 );  
  };
  int mon_laenge() { 
    if (  m < 1 || m > 12 ) {
      return 0;
    }
    return mon[m-1].laenge + (m==2 && schalt()); 
  }
  int jahr_laenge() { 
    return 365 + schalt(); 
  }  
  string mon_name() { 
    return mon[m-1].name; 
  }
  int tag_im_jahr() { 
    datum d = datum(t,m,j);
    int n = d.t;

    for (d.m=1; d.m < m; d.m++ ) 
      n += d.mon_laenge();
    return n;
  }
  friend ostream& operator<<(ostream& os, datum d) {
    os << d.t << ". " << d.mon_name() << ", " << d.j << "\n";
    return os;
  }
  friend istream& operator>>(istream& is, datum& d) {
    cout << "Bitte Tag Monat Jahr eingeben : ";
    int t, m, j;
    is >> t >> m >> j;
    d = datum(t,m,j);
    return is;
  }
  /* Liefert das Datum des 1. des Folgejahres */
  datum inc_jahr() { 
    t = m = 1; j++; 
    return *this; 
  }
  /* Liefert das Datum des 1. des Folgemonats. */
  datum inc_monat() { 
    if (m < 12) { t = 1; m++; }
    else inc_jahr();
    return *this;
  }
  /* Liefert das Datum des folgenden Tages */
  datum operator++() {
    if ( t < mon_laenge() ) t++;
    else   inc_monat();
    return *this;
  }
  /* Berechne u - v */
  friend int operator-(datum u, datum v) {
    int n;
    if (u.j < v.j) return v - u;
    n = u.tag_im_jahr();
    for(u.j = u.j - 1; u.j >= v.j; u.j--) 
      n += u.jahr_laenge();
    n -=  v.tag_im_jahr();
    return n;
  }
  friend datum operator+(datum u, int t) {
    if (t >= 0) {
      while (u.t + t > u.mon_laenge()) { 
	t -= (u.mon_laenge() - u.t + 1);
	u.inc_monat();
      }
      u.t += t;
      return u;
    }
    cout << "Noch nicht implementiert (t negativ) : " << t << "\n" ;
    exit(1);
  }
};

string wochentag(datum d) {
  int t;
  datum e = datum(31,12,2000); /* ist ein Sonntag */
  t = (d-e) % 7;
  if ( t < 0 )  
    t += 7;
  return tage[t];
}

int main() { 
  int t; datum d, dd;
  while(1) {
    cin >> d;
    cout << "Das Datum ist : " << d ;
    cout << "Es ist der " << 
      d.tag_im_jahr() << "-te Tag im Jahr " << d.jahr() << ".\n";
    cout << "Es ist ein " << wochentag(d) << "\n";
    cout << "Der naechste Tag ist : " << ++d;
    cout << "wieviele Tage dazu ? "; cin >> t;
    dd = d + t;
    cout << dd;
    cout << "Unterschied nach diff : " << dd-d << "\n";
  }
}


