// mondlandung.cc

#include <stdio.h>
#include <iostream.h>

#define B 1.62      /*   m/qsec Fallbeschleunigung Mond   */
#define G 9.81      /*   m/qsec Fallbeschleunigung Erde   */

class state {
  double v, h, f, b; 
         // Geschwindigkeit, Hoehe, Treibstoff-Vorrat, Beschleunigung
public:

  // Einzige Konstruktor-Funktion:
  state (double vv, double hh, double ff) {
    v = vv; h = hh; f = (ff >= 0) ? ff : -ff; b = 0.0;
  }

  // Einige Member-Funktionen:
  double height() { return h; }
  double fuel()   { return f; }

  state decel(double ff) {
    ff = (ff >= 0) ? ff : -ff ; // negativer Treibstoff-Verbrauch?? 
    if ( ff >= f ) ff = f;      // Vorrat verbraucht!
    f = f - ff;  b = ff - B;  h = h + v + b/2;  v = v + b;
    return *this;
  }



  void print() {
    if ( h > 0.0 )
      printf("%8.2f %8.2f %8.2f %8.2fg   ::  ", v, h, f, b/G);
    else {
      if ( v <= -2.0 )	printf("Crash:\n");
      else 	        printf("Landung:\n");
      printf("%8.2f %8.2f %8.2f %8.2fg   ::  \n", v, h, f, b/G);
      printf("Aufprall entspricht einem Sturz aus %2.2f m \
Hoehe auf die Erde.\n", v*v/(2*G) );
    }
  }
};  

int main() {
  state s = state(-106.0, 533.0, 140.0);
  double ff;
  printf("    v        h        f          b     :: Treibstoff ?\n");
  while ( s.height() > 0.0 ) {
    ff = 0.0; 
    if ( s.fuel() > 0.0 ) {
      s.print();
      cin >> ff;
    }
    s.decel(ff);
  }
  s.print();
}
