// vektor.cc, Ein erstes Beispiel fuer eine Klassendefinition
#include <iostream.h>
#include <stdio.h>
#include <math.h>


typedef double FLOAT;

class vektor {
  FLOAT x; FLOAT y;             // geschuetzte Komponenten
public:                           // Schnittstelle zur "Aussenwelt" :
  vektor();                       // Constructor-Funktion zur Definition
  vektor(FLOAT, FLOAT);         // Constructor-Funktion zur Initialisierung
  FLOAT laenge();                // Eine Member-Funktion
  FLOAT l_quad();                // dito
  vektor rot(FLOAT);
  friend FLOAT arg(vektor);      // Eine Friend-Funktion
  friend ostream& operator<<(ostream&, vektor);   // Ausgabeoperator
  friend int operator>(vektor, vektor);           // Vergleichsoperator
  friend int operator<(vektor, vektor);           // Vergleichsoperator
};

vektor::vektor() {};
vektor::vektor(FLOAT xx, FLOAT yy) { x = xx; y = yy; }

FLOAT vektor::laenge() { return sqrt(x*x+y*y); }
FLOAT vektor::l_quad() { return x*x+y*y; }

vektor vektor::rot(FLOAT phi) {
  return vektor(cos(phi)*x+sin(phi)*y, -sin(phi)*x+cos(phi)*y);
}

FLOAT arg(vektor z)    { return atan(z.y/z.x); }

ostream& operator<<(ostream& os, vektor z) {
  //return os << '(' << z.x << ',' << z.y << ')';
  char s[100];
  sprintf(s,"(%.1f,%4.1f)", z.x, z.y);
  return os << s;
}

int operator>(vektor u, vektor v) {  return (u.l_quad() > v.l_quad()); }
int operator<(vektor u, vektor v) {  return (u.l_quad() < v.l_quad()); }

//  Ende der Klassendefinition 

#include "quicksort.h"            // enthaelt quicksort- und swap-Template

vektor a[] = { vektor(0,1),vektor(1,2),vektor(2,3),vektor(3,4),
	       vektor(1,1),vektor(2,2),vektor(3,3),vektor(4,4),
	       vektor(1,0)
};

int aa = sizeof(a)/sizeof(vektor);    // Anzahl der Elemente im Array a

int main() {

  vektor u;                     // Hier arbeitet vektor()
  cout << "Ausgabe: u = " << u << '\n';  // Hier arbeitet operator<< = Ausgabe
  u = vektor(12,23);            // Hier arbeitet vektor(double,double)
  vektor v = vektor(34,45);     // Hier arbeiten beide vektor-Constructoren

  cout << "u = " << u << ", v = " << v << '\n';
  cout << "l(u) = " << u.laenge() << ", l(v) = " << v.laenge() << '\n';
  cout << "arg(u) = "<< arg(u) << ", arg(v) = " << arg(v) << '\n';

  if (u < v) cout << " u < v \n"; // Test fuer operator< : lexikographische O.
  else cout << " ! u < v \n";      

  for(int i=0; i<aa; i++) 
    cout << a[i] << " ";
  cout << "\nsortiert:\n";
  quicksort(a,aa);
  for(int i=0; i<aa; i++) 
    cout << a[i] << " ";
  cout << "\ngedreht mit pi/4:\n";
  vektor b[aa];
  for(int i=0; i<aa; i++) 
    b[i] = a[i].rot(M_PI/4);

  for(int i=0; i<aa; i++) 
    cout << b[i] << " ";
  cout << "\n";

}
