// btree.cc : Eine Binaerbaum-Klasse

#include <ctype.h>
#include <iostream.h>
#include <locale.h>
#include "string-class.h"

template<class T>
class tree {
  struct node{
    T e; int c; node *l, *r;   // Element, Zaehler, linker/rechter Teilbaum
    node() { c = 1; l = NULL; r = NULL; }
  } *n;
public:
  tree() { n = NULL; }        // Konstruktor : fuer Deklarationen
  tree(node *nn) { n = nn;}   // Konstruktor : fuer Initialisierungen

  node* insert(const T &e) {  // Member-Fumktion : 
    if (n == NULL) { 
      n = new node;           // liefert und initialisiert struct node n
      n->e = e;               // Datenelement   
    }
    else if (e == n->e) { n->c++; } // e vorhanden, erhoehe Zaehler
    else if (e <  n->e)             // ordne lexikographisch ein :
      n->l = tree(n->l).insert(e); 
    else 
      n->r = tree(n->r).insert(e); 
    return this->n;
  }
  friend ostream& inorder(ostream& os, tree t) {
    if (t.n) {  
      inorder(os, t.n->l);
      os << t.n->e << '(' << t.n->c << ")\n" ; 
      inorder(os, t.n->r);
    }
    return os;
  }
};

bool getword(istream& is, string& s) {
  if ( ! (is >> s) ) return false ;
  char *p, *q;
  p = q = &s[0]; 
  while (*p) {       
    if ( isalpha(*p) ) // Nur alpha-Zeichen werden beruecksichtigt
      *q++ = *p;       // Kopieren von Zeichen 
    p++;
  }
  *q = '\0';
  return true;
}


int main() {
  string s;
  tree<string> tr;              // Deklariere Baum aus Strings 
  setlocale(LC_ALL, "deutsch"); // cf. "man setlocale", "man locale"
  while ( getword(cin, s) ) {
    tr.insert(s);
  }
  inorder(cout, tr);   // Ausgabe der sortierten Woerter
}
