#include <stdio.h>
#include <string.h>
void error(char *s, int i, int j, char *w) {     // Fehlerausgabe
  cerr << s << i << " " << j << " " << w << "...\n";
}
#define STRCMP strcoll // statt: strcmp

class string {
  struct srep {          // String repraesentiert durch 
    char *s;             // Zeiger auf char
    int n;               // Referenz-Zaehler
    srep() { n = 1; }    // initiiert auf 1;
  };
  srep *p;               // und Zeiger auf srep
public:
  string();                             // string x;
  string(const char *);                 // string x = "abc";
  string(const string &);               // string y = x;
  string& operator=(const char *);      // Zuweisung  x = "abc";
  string& operator=(const string& );    // Zuweisung  y = x;
  ~string();                            // Destruktor;
  char& operator[](int i);              // Ueberladung des Index-Operators []
  char operator[](int i) const;  // wird nicht genommen. ??
  const char * cstring() { return p->s; }
  operator char *() const { return p->s; }
  operator unsigned char *() const { return (unsigned char *)p->s; }
  friend ostream& operator<<(ostream&, const string&);
  friend istream& operator>>(istream&, string&);

  friend int operator==(const string& x, const char *s)
  { return STRCMP(x.p->s, s) == 0; }

  friend int operator==(const string& x, const string &y)
  { return STRCMP(x.p->s, y.p->s) == 0; }

  friend int operator!=(const string& x, const char *s)
  { return STRCMP(x.p->s, s) != 0; }

  friend int operator!=(const string& x, const string &y)
  { return STRCMP(x.p->s, y.p->s) != 0; }
  friend int operator<(const string& x, const string &y)
  { return STRCMP(x.p->s, y.p->s) < 0; }
  friend int operator>(const string& x, const string &y)
  { return STRCMP(x.p->s, y.p->s) > 0; }

  friend string operator+(const string& x, const string &y) {
    string s; 
    s.p->s = new char[strlen(x.p->s) + strlen(y.p->s) + 1];
    strcpy(s.p->s,x.p->s); strcat(s.p->s,y.p->s);
    return s;
  }
  int len() { return strlen(p->s); }
  friend int strlen(const string& u) { 
    return strlen(u.p->s); 
  }
  void check(char *u) { // Test-Funktion
    printf("%s : -->n = %3d, s = %s\n", u, p->n, p->s);
  }
};

string::string() {
  p = new srep;
  p->s = 0;
}

string::string(const string& x) {
  x.p->n++;
  p = x.p;
}

string::string(const char *s) {
  p = new srep;
  p->s = new char[ strlen(s) + 1];
  strcpy(p->s,s);
}

string::~string() {
  if (--p->n == 0) {
    delete[] p->s;
    delete p;
  }
}

string& string::operator=(const char *s) {
  if (p->n > 1) {
    p->n--;
    p = new srep;
  }
  else
    delete[] p->s;
  p->s = new char[strlen(s)+1];
  strcpy(p->s ,s);
  return *this;
}

string& string::operator=(const string& x) {
  x.p->n++;
  if (--p->n == 0) {
    delete[] p->s;
    delete p;
  }
  p = x.p;
  return *this;
}

ostream& operator<<(ostream& s, const string& x) {
  // return s << x.p->s << " { Ref-count = " << x.p->n << "}\n";
  return s << x.p->s;
}
istream& operator>>(istream& s, string& x) {
  char buf[1024];
  s.width(1024);
  s >> buf;          // ohne width : Ueberlaufgefahr
  x = buf;
  return s;
}

char& string::operator[](int i) {
  //cout << "first\n";
  if ( (i<0) || (strlen(p->s) < (unsigned int)i) ) 
    error(" 1. Index ausser Bereich : ", i, strlen(p->s), p->s );
  if (p->n > 1) {
    srep* np = new srep;
    np->s = new char[ strlen(p->s) + 1 ];
    strcpy(np->s, p->s);
    p->n--;
    p = np;
  }
  return p->s[i];
}

char string::operator[](int i) const {
  //cout << "second\n";
  if ( (i<0) || (strlen (p->s)) < (unsigned int)i) 
    error("2. Index ausser Bereich", i, strlen(p->s), p->s );
  return p->s[i];
}

